unordered_map.h
Go to the documentation of this file.
// unordered_map implementation -*- C++ -*-
// Copyright (C) 2010-2014 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library. This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// Under Section 7 of GPL version 3, you are granted additional
// permissions described in the GCC Runtime Library Exception, version
// 3.1, as published by the Free Software Foundation.
// You should have received a copy of the GNU General Public License and
// a copy of the GCC Runtime Library Exception along with this program;
// see the files COPYING3 and COPYING.RUNTIME respectively. If not, see
// <http://www.gnu.org/licenses/>.
/** @file bits/unordered_map.h
* This is an internal header file, included by other library headers.
* Do not attempt to use it directly. @headername{unordered_map}
*/
#ifndef _UNORDERED_MAP_H
#define _UNORDERED_MAP_H
namespace std _GLIBCXX_VISIBILITY(default)
{
_GLIBCXX_BEGIN_NAMESPACE_CONTAINER
/// Base types for unordered_map.
template<bool _Cache>
using __umap_traits = __detail::_Hashtable_traits<_Cache, false, true>;
template<typename _Key,
typename _Tp,
typename _Hash = hash<_Key>,
typename _Pred = std::equal_to<_Key>,
typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >,
typename _Tr = __umap_traits<__cache_default<_Key, _Hash>::value>>
using __umap_hashtable = _Hashtable<_Key, std::pair<const _Key, _Tp>,
_Alloc, __detail::_Select1st,
_Pred, _Hash,
__detail::_Mod_range_hashing,
__detail::_Default_ranged_hash,
__detail::_Prime_rehash_policy, _Tr>;
/// Base types for unordered_multimap.
template<bool _Cache>
using __ummap_traits = __detail::_Hashtable_traits<_Cache, false, false>;
template<typename _Key,
typename _Tp,
typename _Hash = hash<_Key>,
typename _Pred = std::equal_to<_Key>,
typename _Alloc = std::allocator<std::pair<const _Key, _Tp> >,
typename _Tr = __ummap_traits<__cache_default<_Key, _Hash>::value>>
using __ummap_hashtable = _Hashtable<_Key, std::pair<const _Key, _Tp>,
_Alloc, __detail::_Select1st,
_Pred, _Hash,
__detail::_Mod_range_hashing,
__detail::_Default_ranged_hash,
__detail::_Prime_rehash_policy, _Tr>;
/**
* @brief A standard container composed of unique keys (containing
* at most one of each key value) that associates values of another type
* with the keys.
*
* @ingroup unordered_associative_containers
*
* @tparam _Key Type of key objects.
* @tparam _Tp Type of mapped objects.
* @tparam _Hash Hashing function object type, defaults to hash<_Value>.
* @tparam _Pred Predicate function object type, defaults
* to equal_to<_Value>.
* @tparam _Alloc Allocator type, defaults to
* std::allocator<std::pair<const _Key, _Tp>>.
*
* Meets the requirements of a <a href="tables.html#65">container</a>, and
* <a href="tables.html#xx">unordered associative container</a>
*
* The resulting value type of the container is std::pair<const _Key, _Tp>.
*
* Base is _Hashtable, dispatched at compile time via template
* alias __umap_hashtable.
*/
template<class _Key, class _Tp,
class _Hash = hash<_Key>,
class _Pred = std::equal_to<_Key>,
class _Alloc = std::allocator<std::pair<const _Key, _Tp> > >
class unordered_map
{
typedef __umap_hashtable<_Key, _Tp, _Hash, _Pred, _Alloc> _Hashtable;
_Hashtable _M_h;
public:
// typedefs:
//@{
/// Public typedefs.
typedef typename _Hashtable::key_type key_type;
typedef typename _Hashtable::value_type value_type;
typedef typename _Hashtable::mapped_type mapped_type;
typedef typename _Hashtable::hasher hasher;
typedef typename _Hashtable::key_equal key_equal;
typedef typename _Hashtable::allocator_type allocator_type;
//@}
//@{
/// Iterator-related typedefs.
typedef typename _Hashtable::pointer pointer;
typedef typename _Hashtable::const_pointer const_pointer;
typedef typename _Hashtable::reference reference;
typedef typename _Hashtable::const_reference const_reference;
typedef typename _Hashtable::iterator iterator;
typedef typename _Hashtable::const_iterator const_iterator;
typedef typename _Hashtable::local_iterator local_iterator;
typedef typename _Hashtable::const_local_iterator const_local_iterator;
typedef typename _Hashtable::size_type size_type;
typedef typename _Hashtable::difference_type difference_type;
//@}
//construct/destroy/copy
/**
* @brief Default constructor creates no elements.
* @param __n Initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*/
explicit
unordered_map(size_type __n = 10,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__n, __hf, __eql, __a)
{ }
/**
* @brief Builds an %unordered_map from a range.
* @param __first An input iterator.
* @param __last An input iterator.
* @param __n Minimal initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*
* Create an %unordered_map consisting of copies of the elements from
* [__first,__last). This is linear in N (where N is
* distance(__first,__last)).
*/
template<typename _InputIterator>
unordered_map(_InputIterator __f, _InputIterator __l,
size_type __n = 0,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__f, __l, __n, __hf, __eql, __a)
{ }
/// Copy constructor.
unordered_map(const unordered_map&) = default;
/// Move constructor.
unordered_map(unordered_map&&) = default;
/**
* @brief Creates an %unordered_map with no elements.
* @param __a An allocator object.
*/
explicit
unordered_map(const allocator_type& __a)
: _M_h(__a)
{ }
/*
* @brief Copy constructor with allocator argument.
* @param __uset Input %unordered_map to copy.
* @param __a An allocator object.
*/
unordered_map(const unordered_map& __umap,
const allocator_type& __a)
: _M_h(__umap._M_h, __a)
{ }
/*
* @brief Move constructor with allocator argument.
* @param __uset Input %unordered_map to move.
* @param __a An allocator object.
*/
unordered_map(unordered_map&& __umap,
const allocator_type& __a)
: _M_h(std::move(__umap._M_h), __a)
{ }
/**
* @brief Builds an %unordered_map from an initializer_list.
* @param __l An initializer_list.
* @param __n Minimal initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*
* Create an %unordered_map consisting of copies of the elements in the
* list. This is linear in N (where N is @a __l.size()).
*/
unordered_map(initializer_list<value_type> __l,
size_type __n = 0,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__l, __n, __hf, __eql, __a)
{ }
/// Copy assignment operator.
unordered_map&
operator=(const unordered_map&) = default;
/// Move assignment operator.
unordered_map&
operator=(unordered_map&&) = default;
/**
* @brief %Unordered_map list assignment operator.
* @param __l An initializer_list.
*
* This function fills an %unordered_map with copies of the elements in
* the initializer list @a __l.
*
* Note that the assignment completely changes the %unordered_map and
* that the resulting %unordered_map's size is the same as the number
* of elements assigned. Old data may be lost.
*/
unordered_map&
operator=(initializer_list<value_type> __l)
{
_M_h = __l;
return *this;
}
/// Returns the allocator object with which the %unordered_map was
/// constructed.
allocator_type
get_allocator() const noexcept
{ return _M_h.get_allocator(); }
// size and capacity:
/// Returns true if the %unordered_map is empty.
bool
empty() const noexcept
{ return _M_h.empty(); }
/// Returns the size of the %unordered_map.
size_type
size() const noexcept
{ return _M_h.size(); }
/// Returns the maximum size of the %unordered_map.
size_type
max_size() const noexcept
{ return _M_h.max_size(); }
// iterators.
/**
* Returns a read/write iterator that points to the first element in the
* %unordered_map.
*/
iterator
begin() noexcept
{ return _M_h.begin(); }
//@{
/**
* Returns a read-only (constant) iterator that points to the first
* element in the %unordered_map.
*/
const_iterator
begin() const noexcept
{ return _M_h.begin(); }
const_iterator
cbegin() const noexcept
{ return _M_h.begin(); }
//@}
/**
* Returns a read/write iterator that points one past the last element in
* the %unordered_map.
*/
iterator
end() noexcept
{ return _M_h.end(); }
//@{
/**
* Returns a read-only (constant) iterator that points one past the last
* element in the %unordered_map.
*/
const_iterator
end() const noexcept
{ return _M_h.end(); }
const_iterator
cend() const noexcept
{ return _M_h.end(); }
//@}
// modifiers.
/**
* @brief Attempts to build and insert a std::pair into the %unordered_map.
*
* @param __args Arguments used to generate a new pair instance (see
* std::piecewise_contruct for passing arguments to each
* part of the pair constructor).
*
* @return A pair, of which the first element is an iterator that points
* to the possibly inserted pair, and the second is a bool that
* is true if the pair was actually inserted.
*
* This function attempts to build and insert a (key, value) %pair into
* the %unordered_map.
* An %unordered_map relies on unique keys and thus a %pair is only
* inserted if its first element (the key) is not already present in the
* %unordered_map.
*
* Insertion requires amortized constant time.
*/
template<typename... _Args>
std::pair<iterator, bool>
emplace(_Args&&... __args)
{ return _M_h.emplace(std::forward<_Args>(__args)...); }
/**
* @brief Attempts to build and insert a std::pair into the %unordered_map.
*
* @param __pos An iterator that serves as a hint as to where the pair
* should be inserted.
* @param __args Arguments used to generate a new pair instance (see
* std::piecewise_contruct for passing arguments to each
* part of the pair constructor).
* @return An iterator that points to the element with key of the
* std::pair built from @a __args (may or may not be that
* std::pair).
*
* This function is not concerned about whether the insertion took place,
* and thus does not return a boolean like the single-argument emplace()
* does.
* Note that the first parameter is only a hint and can potentially
* improve the performance of the insertion process. A bad hint would
* cause no gains in efficiency.
*
* See
* http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html
* for more on @a hinting.
*
* Insertion requires amortized constant time.
*/
template<typename... _Args>
iterator
emplace_hint(const_iterator __pos, _Args&&... __args)
{ return _M_h.emplace_hint(__pos, std::forward<_Args>(__args)...); }
//@{
/**
* @brief Attempts to insert a std::pair into the %unordered_map.
* @param __x Pair to be inserted (see std::make_pair for easy
* creation of pairs).
*
* @return A pair, of which the first element is an iterator that
* points to the possibly inserted pair, and the second is
* a bool that is true if the pair was actually inserted.
*
* This function attempts to insert a (key, value) %pair into the
* %unordered_map. An %unordered_map relies on unique keys and thus a
* %pair is only inserted if its first element (the key) is not already
* present in the %unordered_map.
*
* Insertion requires amortized constant time.
*/
std::pair<iterator, bool>
insert(const value_type& __x)
{ return _M_h.insert(__x); }
template<typename _Pair, typename = typename
std::enable_if<std::is_constructible<value_type,
_Pair&&>::value>::type>
std::pair<iterator, bool>
insert(_Pair&& __x)
{ return _M_h.insert(std::forward<_Pair>(__x)); }
//@}
//@{
/**
* @brief Attempts to insert a std::pair into the %unordered_map.
* @param __hint An iterator that serves as a hint as to where the
* pair should be inserted.
* @param __x Pair to be inserted (see std::make_pair for easy creation
* of pairs).
* @return An iterator that points to the element with key of
* @a __x (may or may not be the %pair passed in).
*
* This function is not concerned about whether the insertion took place,
* and thus does not return a boolean like the single-argument insert()
* does. Note that the first parameter is only a hint and can
* potentially improve the performance of the insertion process. A bad
* hint would cause no gains in efficiency.
*
* See
* http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html
* for more on @a hinting.
*
* Insertion requires amortized constant time.
*/
iterator
insert(const_iterator __hint, const value_type& __x)
{ return _M_h.insert(__hint, __x); }
template<typename _Pair, typename = typename
std::enable_if<std::is_constructible<value_type,
_Pair&&>::value>::type>
iterator
insert(const_iterator __hint, _Pair&& __x)
{ return _M_h.insert(__hint, std::forward<_Pair>(__x)); }
//@}
/**
* @brief A template function that attempts to insert a range of
* elements.
* @param __first Iterator pointing to the start of the range to be
* inserted.
* @param __last Iterator pointing to the end of the range.
*
* Complexity similar to that of the range constructor.
*/
template<typename _InputIterator>
void
insert(_InputIterator __first, _InputIterator __last)
{ _M_h.insert(__first, __last); }
/**
* @brief Attempts to insert a list of elements into the %unordered_map.
* @param __l A std::initializer_list<value_type> of elements
* to be inserted.
*
* Complexity similar to that of the range constructor.
*/
void
insert(initializer_list<value_type> __l)
{ _M_h.insert(__l); }
//@{
/**
* @brief Erases an element from an %unordered_map.
* @param __position An iterator pointing to the element to be erased.
* @return An iterator pointing to the element immediately following
* @a __position prior to the element being erased. If no such
* element exists, end() is returned.
*
* This function erases an element, pointed to by the given iterator,
* from an %unordered_map.
* Note that this function only erases the element, and that if the
* element is itself a pointer, the pointed-to memory is not touched in
* any way. Managing the pointer is the user's responsibility.
*/
iterator
erase(const_iterator __position)
{ return _M_h.erase(__position); }
// LWG 2059.
iterator
erase(iterator __it)
{ return _M_h.erase(__it); }
//@}
/**
* @brief Erases elements according to the provided key.
* @param __x Key of element to be erased.
* @return The number of elements erased.
*
* This function erases all the elements located by the given key from
* an %unordered_map. For an %unordered_map the result of this function
* can only be 0 (not present) or 1 (present).
* Note that this function only erases the element, and that if the
* element is itself a pointer, the pointed-to memory is not touched in
* any way. Managing the pointer is the user's responsibility.
*/
size_type
erase(const key_type& __x)
{ return _M_h.erase(__x); }
/**
* @brief Erases a [__first,__last) range of elements from an
* %unordered_map.
* @param __first Iterator pointing to the start of the range to be
* erased.
* @param __last Iterator pointing to the end of the range to
* be erased.
* @return The iterator @a __last.
*
* This function erases a sequence of elements from an %unordered_map.
* Note that this function only erases the elements, and that if
* the element is itself a pointer, the pointed-to memory is not touched
* in any way. Managing the pointer is the user's responsibility.
*/
iterator
erase(const_iterator __first, const_iterator __last)
{ return _M_h.erase(__first, __last); }
/**
* Erases all elements in an %unordered_map.
* Note that this function only erases the elements, and that if the
* elements themselves are pointers, the pointed-to memory is not touched
* in any way. Managing the pointer is the user's responsibility.
*/
void
clear() noexcept
{ _M_h.clear(); }
/**
* @brief Swaps data with another %unordered_map.
* @param __x An %unordered_map of the same element and allocator
* types.
*
* This exchanges the elements between two %unordered_map in constant time.
* Note that the global std::swap() function is specialized such that
* std::swap(m1,m2) will feed to this function.
*/
void
swap(unordered_map& __x)
noexcept( noexcept(_M_h.swap(__x._M_h)) )
{ _M_h.swap(__x._M_h); }
// observers.
/// Returns the hash functor object with which the %unordered_map was
/// constructed.
hasher
hash_function() const
{ return _M_h.hash_function(); }
/// Returns the key comparison object with which the %unordered_map was
/// constructed.
key_equal
key_eq() const
{ return _M_h.key_eq(); }
// lookup.
//@{
/**
* @brief Tries to locate an element in an %unordered_map.
* @param __x Key to be located.
* @return Iterator pointing to sought-after element, or end() if not
* found.
*
* This function takes a key and tries to locate the element with which
* the key matches. If successful the function returns an iterator
* pointing to the sought after element. If unsuccessful it returns the
* past-the-end ( @c end() ) iterator.
*/
iterator
find(const key_type& __x)
{ return _M_h.find(__x); }
const_iterator
find(const key_type& __x) const
{ return _M_h.find(__x); }
//@}
/**
* @brief Finds the number of elements.
* @param __x Key to count.
* @return Number of elements with specified key.
*
* This function only makes sense for %unordered_multimap; for
* %unordered_map the result will either be 0 (not present) or 1
* (present).
*/
size_type
count(const key_type& __x) const
{ return _M_h.count(__x); }
//@{
/**
* @brief Finds a subsequence matching given key.
* @param __x Key to be located.
* @return Pair of iterators that possibly points to the subsequence
* matching given key.
*
* This function probably only makes sense for %unordered_multimap.
*/
std::pair<iterator, iterator>
equal_range(const key_type& __x)
{ return _M_h.equal_range(__x); }
std::pair<const_iterator, const_iterator>
equal_range(const key_type& __x) const
{ return _M_h.equal_range(__x); }
//@}
//@{
/**
* @brief Subscript ( @c [] ) access to %unordered_map data.
* @param __k The key for which data should be retrieved.
* @return A reference to the data of the (key,data) %pair.
*
* Allows for easy lookup with the subscript ( @c [] )operator. Returns
* data associated with the key specified in subscript. If the key does
* not exist, a pair with that key is created using default values, which
* is then returned.
*
* Lookup requires constant time.
*/
mapped_type&
operator[](const key_type& __k)
{ return _M_h[__k]; }
mapped_type&
operator[](key_type&& __k)
{ return _M_h[std::move(__k)]; }
//@}
//@{
/**
* @brief Access to %unordered_map data.
* @param __k The key for which data should be retrieved.
* @return A reference to the data whose key is equal to @a __k, if
* such a data is present in the %unordered_map.
* @throw std::out_of_range If no such data is present.
*/
mapped_type&
at(const key_type& __k)
{ return _M_h.at(__k); }
const mapped_type&
at(const key_type& __k) const
{ return _M_h.at(__k); }
//@}
// bucket interface.
/// Returns the number of buckets of the %unordered_map.
size_type
bucket_count() const noexcept
{ return _M_h.bucket_count(); }
/// Returns the maximum number of buckets of the %unordered_map.
size_type
max_bucket_count() const noexcept
{ return _M_h.max_bucket_count(); }
/*
* @brief Returns the number of elements in a given bucket.
* @param __n A bucket index.
* @return The number of elements in the bucket.
*/
size_type
bucket_size(size_type __n) const
{ return _M_h.bucket_size(__n); }
/*
* @brief Returns the bucket index of a given element.
* @param __key A key instance.
* @return The key bucket index.
*/
size_type
bucket(const key_type& __key) const
{ return _M_h.bucket(__key); }
/**
* @brief Returns a read/write iterator pointing to the first bucket
* element.
* @param __n The bucket index.
* @return A read/write local iterator.
*/
local_iterator
begin(size_type __n)
{ return _M_h.begin(__n); }
//@{
/**
* @brief Returns a read-only (constant) iterator pointing to the first
* bucket element.
* @param __n The bucket index.
* @return A read-only local iterator.
*/
const_local_iterator
begin(size_type __n) const
{ return _M_h.begin(__n); }
const_local_iterator
cbegin(size_type __n) const
{ return _M_h.cbegin(__n); }
//@}
/**
* @brief Returns a read/write iterator pointing to one past the last
* bucket elements.
* @param __n The bucket index.
* @return A read/write local iterator.
*/
local_iterator
end(size_type __n)
{ return _M_h.end(__n); }
//@{
/**
* @brief Returns a read-only (constant) iterator pointing to one past
* the last bucket elements.
* @param __n The bucket index.
* @return A read-only local iterator.
*/
const_local_iterator
end(size_type __n) const
{ return _M_h.end(__n); }
const_local_iterator
cend(size_type __n) const
{ return _M_h.cend(__n); }
//@}
// hash policy.
/// Returns the average number of elements per bucket.
float
load_factor() const noexcept
{ return _M_h.load_factor(); }
/// Returns a positive number that the %unordered_map tries to keep the
/// load factor less than or equal to.
float
max_load_factor() const noexcept
{ return _M_h.max_load_factor(); }
/**
* @brief Change the %unordered_map maximum load factor.
* @param __z The new maximum load factor.
*/
void
max_load_factor(float __z)
{ _M_h.max_load_factor(__z); }
/**
* @brief May rehash the %unordered_map.
* @param __n The new number of buckets.
*
* Rehash will occur only if the new number of buckets respect the
* %unordered_map maximum load factor.
*/
void
rehash(size_type __n)
{ _M_h.rehash(__n); }
/**
* @brief Prepare the %unordered_map for a specified number of
* elements.
* @param __n Number of elements required.
*
* Same as rehash(ceil(n / max_load_factor())).
*/
void
reserve(size_type __n)
{ _M_h.reserve(__n); }
template<typename _Key1, typename _Tp1, typename _Hash1, typename _Pred1,
typename _Alloc1>
friend bool
operator==(const unordered_map<_Key1, _Tp1, _Hash1, _Pred1, _Alloc1>&,
const unordered_map<_Key1, _Tp1, _Hash1, _Pred1, _Alloc1>&);
};
/**
* @brief A standard container composed of equivalent keys
* (possibly containing multiple of each key value) that associates
* values of another type with the keys.
*
* @ingroup unordered_associative_containers
*
* @tparam _Key Type of key objects.
* @tparam _Tp Type of mapped objects.
* @tparam _Hash Hashing function object type, defaults to hash<_Value>.
* @tparam _Pred Predicate function object type, defaults
* to equal_to<_Value>.
* @tparam _Alloc Allocator type, defaults to
* std::allocator<std::pair<const _Key, _Tp>>.
*
* Meets the requirements of a <a href="tables.html#65">container</a>, and
* <a href="tables.html#xx">unordered associative container</a>
*
* The resulting value type of the container is std::pair<const _Key, _Tp>.
*
* Base is _Hashtable, dispatched at compile time via template
* alias __ummap_hashtable.
*/
template<class _Key, class _Tp,
class _Hash = hash<_Key>,
class _Pred = std::equal_to<_Key>,
class _Alloc = std::allocator<std::pair<const _Key, _Tp> > >
class unordered_multimap
{
typedef __ummap_hashtable<_Key, _Tp, _Hash, _Pred, _Alloc> _Hashtable;
_Hashtable _M_h;
public:
// typedefs:
//@{
/// Public typedefs.
typedef typename _Hashtable::key_type key_type;
typedef typename _Hashtable::value_type value_type;
typedef typename _Hashtable::mapped_type mapped_type;
typedef typename _Hashtable::hasher hasher;
typedef typename _Hashtable::key_equal key_equal;
typedef typename _Hashtable::allocator_type allocator_type;
//@}
//@{
/// Iterator-related typedefs.
typedef typename _Hashtable::pointer pointer;
typedef typename _Hashtable::const_pointer const_pointer;
typedef typename _Hashtable::reference reference;
typedef typename _Hashtable::const_reference const_reference;
typedef typename _Hashtable::iterator iterator;
typedef typename _Hashtable::const_iterator const_iterator;
typedef typename _Hashtable::local_iterator local_iterator;
typedef typename _Hashtable::const_local_iterator const_local_iterator;
typedef typename _Hashtable::size_type size_type;
typedef typename _Hashtable::difference_type difference_type;
//@}
//construct/destroy/copy
/**
* @brief Default constructor creates no elements.
* @param __n Initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*/
explicit
unordered_multimap(size_type __n = 10,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__n, __hf, __eql, __a)
{ }
/**
* @brief Builds an %unordered_multimap from a range.
* @param __first An input iterator.
* @param __last An input iterator.
* @param __n Minimal initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*
* Create an %unordered_multimap consisting of copies of the elements
* from [__first,__last). This is linear in N (where N is
* distance(__first,__last)).
*/
template<typename _InputIterator>
unordered_multimap(_InputIterator __f, _InputIterator __l,
size_type __n = 0,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__f, __l, __n, __hf, __eql, __a)
{ }
/// Copy constructor.
unordered_multimap(const unordered_multimap&) = default;
/// Move constructor.
unordered_multimap(unordered_multimap&&) = default;
/**
* @brief Creates an %unordered_multimap with no elements.
* @param __a An allocator object.
*/
explicit
unordered_multimap(const allocator_type& __a)
: _M_h(__a)
{ }
/*
* @brief Copy constructor with allocator argument.
* @param __uset Input %unordered_multimap to copy.
* @param __a An allocator object.
*/
unordered_multimap(const unordered_multimap& __ummap,
const allocator_type& __a)
: _M_h(__ummap._M_h, __a)
{ }
/*
* @brief Move constructor with allocator argument.
* @param __uset Input %unordered_multimap to move.
* @param __a An allocator object.
*/
unordered_multimap(unordered_multimap&& __ummap,
const allocator_type& __a)
: _M_h(std::move(__ummap._M_h), __a)
{ }
/**
* @brief Builds an %unordered_multimap from an initializer_list.
* @param __l An initializer_list.
* @param __n Minimal initial number of buckets.
* @param __hf A hash functor.
* @param __eql A key equality functor.
* @param __a An allocator object.
*
* Create an %unordered_multimap consisting of copies of the elements in
* the list. This is linear in N (where N is @a __l.size()).
*/
unordered_multimap(initializer_list<value_type> __l,
size_type __n = 0,
const hasher& __hf = hasher(),
const key_equal& __eql = key_equal(),
const allocator_type& __a = allocator_type())
: _M_h(__l, __n, __hf, __eql, __a)
{ }
/// Copy assignment operator.
unordered_multimap&
operator=(const unordered_multimap&) = default;
/// Move assignment operator.
unordered_multimap&
operator=(unordered_multimap&&) = default;
/**
* @brief %Unordered_multimap list assignment operator.
* @param __l An initializer_list.
*
* This function fills an %unordered_multimap with copies of the elements
* in the initializer list @a __l.
*
* Note that the assignment completely changes the %unordered_multimap
* and that the resulting %unordered_multimap's size is the same as the
* number of elements assigned. Old data may be lost.
*/
unordered_multimap&
operator=(initializer_list<value_type> __l)
{
_M_h = __l;
return *this;
}
/// Returns the allocator object with which the %unordered_multimap was
/// constructed.
allocator_type
get_allocator() const noexcept
{ return _M_h.get_allocator(); }
// size and capacity:
/// Returns true if the %unordered_multimap is empty.
bool
empty() const noexcept
{ return _M_h.empty(); }
/// Returns the size of the %unordered_multimap.
size_type
size() const noexcept
{ return _M_h.size(); }
/// Returns the maximum size of the %unordered_multimap.
size_type
max_size() const noexcept
{ return _M_h.max_size(); }
// iterators.
/**
* Returns a read/write iterator that points to the first element in the
* %unordered_multimap.
*/
iterator
begin() noexcept
{ return _M_h.begin(); }
//@{
/**
* Returns a read-only (constant) iterator that points to the first
* element in the %unordered_multimap.
*/
const_iterator
begin() const noexcept
{ return _M_h.begin(); }
const_iterator
cbegin() const noexcept
{ return _M_h.begin(); }
//@}
/**
* Returns a read/write iterator that points one past the last element in
* the %unordered_multimap.
*/
iterator
end() noexcept
{ return _M_h.end(); }
//@{
/**
* Returns a read-only (constant) iterator that points one past the last
* element in the %unordered_multimap.
*/
const_iterator
end() const noexcept
{ return _M_h.end(); }
const_iterator
cend() const noexcept
{ return _M_h.end(); }
//@}
// modifiers.
/**
* @brief Attempts to build and insert a std::pair into the
* %unordered_multimap.
*
* @param __args Arguments used to generate a new pair instance (see
* std::piecewise_contruct for passing arguments to each
* part of the pair constructor).
*
* @return An iterator that points to the inserted pair.
*
* This function attempts to build and insert a (key, value) %pair into
* the %unordered_multimap.
*
* Insertion requires amortized constant time.
*/
template<typename... _Args>
iterator
emplace(_Args&&... __args)
{ return _M_h.emplace(std::forward<_Args>(__args)...); }
/**
* @brief Attempts to build and insert a std::pair into the %unordered_multimap.
*
* @param __pos An iterator that serves as a hint as to where the pair
* should be inserted.
* @param __args Arguments used to generate a new pair instance (see
* std::piecewise_contruct for passing arguments to each
* part of the pair constructor).
* @return An iterator that points to the element with key of the
* std::pair built from @a __args.
*
* Note that the first parameter is only a hint and can potentially
* improve the performance of the insertion process. A bad hint would
* cause no gains in efficiency.
*
* See
* http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html
* for more on @a hinting.
*
* Insertion requires amortized constant time.
*/
template<typename... _Args>
iterator
emplace_hint(const_iterator __pos, _Args&&... __args)
{ return _M_h.emplace_hint(__pos, std::forward<_Args>(__args)...); }
//@{
/**
* @brief Inserts a std::pair into the %unordered_multimap.
* @param __x Pair to be inserted (see std::make_pair for easy
* creation of pairs).
*
* @return An iterator that points to the inserted pair.
*
* Insertion requires amortized constant time.
*/
iterator
insert(const value_type& __x)
{ return _M_h.insert(__x); }
template<typename _Pair, typename = typename
std::enable_if<std::is_constructible<value_type,
_Pair&&>::value>::type>
iterator
insert(_Pair&& __x)
{ return _M_h.insert(std::forward<_Pair>(__x)); }
//@}
//@{
/**
* @brief Inserts a std::pair into the %unordered_multimap.
* @param __hint An iterator that serves as a hint as to where the
* pair should be inserted.
* @param __x Pair to be inserted (see std::make_pair for easy creation
* of pairs).
* @return An iterator that points to the element with key of
* @a __x (may or may not be the %pair passed in).
*
* Note that the first parameter is only a hint and can potentially
* improve the performance of the insertion process. A bad hint would
* cause no gains in efficiency.
*
* See
* http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html
* for more on @a hinting.
*
* Insertion requires amortized constant time.
*/
iterator
insert(const_iterator __hint, const value_type& __x)
{ return _M_h.insert(__hint, __x); }
template<typename _Pair, typename = typename
std::enable_if<std::is_constructible<value_type,
_Pair&&>::value>::type>
iterator
insert(const_iterator __hint, _Pair&& __x)
{ return _M_h.insert(__hint, std::forward<_Pair>(__x)); }
//@}
/**
* @brief A template function that attempts to insert a range of
* elements.
* @param __first Iterator pointing to the start of the range to be
* inserted.
* @param __last Iterator pointing to the end of the range.
*
* Complexity similar to that of the range constructor.
*/
template<typename _InputIterator>
void
insert(_InputIterator __first, _InputIterator __last)
{ _M_h.insert(__first, __last); }
/**
* @brief Attempts to insert a list of elements into the
* %unordered_multimap.
* @param __l A std::initializer_list<value_type> of elements
* to be inserted.
*
* Complexity similar to that of the range constructor.
*/
void
insert(initializer_list<value_type> __l)
{ _M_h.insert(__l); }
//@{
/**
* @brief Erases an element from an %unordered_multimap.
* @param __position An iterator pointing to the element to be erased.
* @return An iterator pointing to the element immediately following
* @a __position prior to the element being erased. If no such
* element exists, end() is returned.
*
* This function erases an element, pointed to by the given iterator,
* from an %unordered_multimap.
* Note that this function only erases the element, and that if the
* element is itself a pointer, the pointed-to memory is not touched in
* any way. Managing the pointer is the user's responsibility.
*/
iterator
erase(const_iterator __position)
{ return _M_h.erase(__position); }
// LWG 2059.
iterator
erase(iterator __it)
{ return _M_h.erase(__it); }
//@}
/**
* @brief Erases elements according to the provided key.
* @param __x Key of elements to be erased.
* @return The number of elements erased.
*
* This function erases all the elements located by the given key from
* an %unordered_multimap.
* Note that this function only erases the element, and that if the
* element is itself a pointer, the pointed-to memory is not touched in
* any way. Managing the pointer is the user's responsibility.
*/
size_type
erase(const key_type& __x)
{ return _M_h.erase(__x); }
/**
* @brief Erases a [__first,__last) range of elements from an
* %unordered_multimap.
* @param __first Iterator pointing to the start of the range to be
* erased.
* @param __last Iterator pointing to the end of the range to
* be erased.
* @return The iterator @a __last.
*
* This function erases a sequence of elements from an
* %unordered_multimap.
* Note that this function only erases the elements, and that if
* the element is itself a pointer, the pointed-to memory is not touched
* in any way. Managing the pointer is the user's responsibility.
*/
iterator
erase(const_iterator __first, const_iterator __last)
{ return _M_h.erase(__first, __last); }
/**
* Erases all elements in an %unordered_multimap.
* Note that this function only erases the elements, and that if the
* elements themselves are pointers, the pointed-to memory is not touched
* in any way. Managing the pointer is the user's responsibility.
*/
void
clear() noexcept
{ _M_h.clear(); }
/**
* @brief Swaps data with another %unordered_multimap.
* @param __x An %unordered_multimap of the same element and allocator
* types.
*
* This exchanges the elements between two %unordered_multimap in
* constant time.
* Note that the global std::swap() function is specialized such that
* std::swap(m1,m2) will feed to this function.
*/
void
swap(unordered_multimap& __x)
noexcept( noexcept(_M_h.swap(__x._M_h)) )
{ _M_h.swap(__x._M_h); }
// observers.
/// Returns the hash functor object with which the %unordered_multimap
/// was constructed.
hasher
hash_function() const
{ return _M_h.hash_function(); }
/// Returns the key comparison object with which the %unordered_multimap
/// was constructed.
key_equal
key_eq() const
{ return _M_h.key_eq(); }
// lookup.
//@{
/**
* @brief Tries to locate an element in an %unordered_multimap.
* @param __x Key to be located.
* @return Iterator pointing to sought-after element, or end() if not
* found.
*
* This function takes a key and tries to locate the element with which
* the key matches. If successful the function returns an iterator
* pointing to the sought after element. If unsuccessful it returns the
* past-the-end ( @c end() ) iterator.
*/
iterator
find(const key_type& __x)
{ return _M_h.find(__x); }
const_iterator
find(const key_type& __x) const
{ return _M_h.find(__x); }
//@}
/**
* @brief Finds the number of elements.
* @param __x Key to count.
* @return Number of elements with specified key.
*/
size_type
count(const key_type& __x) const
{ return _M_h.count(__x); }
//@{
/**
* @brief Finds a subsequence matching given key.
* @param __x Key to be located.
* @return Pair of iterators that possibly points to the subsequence
* matching given key.
*/
std::pair<iterator, iterator>
equal_range(const key_type& __x)
{ return _M_h.equal_range(__x); }
std::pair<const_iterator, const_iterator>
equal_range(const key_type& __x) const
{ return _M_h.equal_range(__x); }
//@}
// bucket interface.
/// Returns the number of buckets of the %unordered_multimap.
size_type
bucket_count() const noexcept
{ return _M_h.bucket_count(); }
/// Returns the maximum number of buckets of the %unordered_multimap.
size_type
max_bucket_count() const noexcept
{ return _M_h.max_bucket_count(); }
/*
* @brief Returns the number of elements in a given bucket.
* @param __n A bucket index.
* @return The number of elements in the bucket.
*/
size_type
bucket_size(size_type __n) const
{ return _M_h.bucket_size(__n); }
/*
* @brief Returns the bucket index of a given element.
* @param __key A key instance.
* @return The key bucket index.
*/
size_type
bucket(const key_type& __key) const
{ return _M_h.bucket(__key); }
/**
* @brief Returns a read/write iterator pointing to the first bucket
* element.
* @param __n The bucket index.
* @return A read/write local iterator.
*/
local_iterator
begin(size_type __n)
{ return _M_h.begin(__n); }
//@{
/**
* @brief Returns a read-only (constant) iterator pointing to the first
* bucket element.
* @param __n The bucket index.
* @return A read-only local iterator.
*/
const_local_iterator
begin(size_type __n) const
{ return _M_h.begin(__n); }
const_local_iterator
cbegin(size_type __n) const
{ return _M_h.cbegin(__n); }
//@}
/**
* @brief Returns a read/write iterator pointing to one past the last
* bucket elements.
* @param __n The bucket index.
* @return A read/write local iterator.
*/
local_iterator
end(size_type __n)
{ return _M_h.end(__n); }
//@{
/**
* @brief Returns a read-only (constant) iterator pointing to one past
* the last bucket elements.
* @param __n The bucket index.
* @return A read-only local iterator.
*/
const_local_iterator
end(size_type __n) const
{ return _M_h.end(__n); }
const_local_iterator
cend(size_type __n) const
{ return _M_h.cend(__n); }
//@}
// hash policy.
/// Returns the average number of elements per bucket.
float
load_factor() const noexcept
{ return _M_h.load_factor(); }
/// Returns a positive number that the %unordered_multimap tries to keep
/// the load factor less than or equal to.
float
max_load_factor() const noexcept
{ return _M_h.max_load_factor(); }
/**
* @brief Change the %unordered_multimap maximum load factor.
* @param __z The new maximum load factor.
*/
void
max_load_factor(float __z)
{ _M_h.max_load_factor(__z); }
/**
* @brief May rehash the %unordered_multimap.
* @param __n The new number of buckets.
*
* Rehash will occur only if the new number of buckets respect the
* %unordered_multimap maximum load factor.
*/
void
rehash(size_type __n)
{ _M_h.rehash(__n); }
/**
* @brief Prepare the %unordered_multimap for a specified number of
* elements.
* @param __n Number of elements required.
*
* Same as rehash(ceil(n / max_load_factor())).
*/
void
reserve(size_type __n)
{ _M_h.reserve(__n); }
template<typename _Key1, typename _Tp1, typename _Hash1, typename _Pred1,
typename _Alloc1>
friend bool
operator==(const unordered_multimap<_Key1, _Tp1,
_Hash1, _Pred1, _Alloc1>&,
const unordered_multimap<_Key1, _Tp1,
_Hash1, _Pred1, _Alloc1>&);
};
template<class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>
inline void
swap(unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>& __x,
unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>& __y)
{ __x.swap(__y); }
template<class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>
inline void
swap(unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>& __x,
unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>& __y)
{ __x.swap(__y); }
template<class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>
inline bool
operator==(const unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>& __x,
const unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>& __y)
{ return __x._M_h._M_equal(__y._M_h); }
template<class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>
inline bool
operator!=(const unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>& __x,
const unordered_map<_Key, _Tp, _Hash, _Pred, _Alloc>& __y)
{ return !(__x == __y); }
template<class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>
inline bool
operator==(const unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>& __x,
const unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>& __y)
{ return __x._M_h._M_equal(__y._M_h); }
template<class _Key, class _Tp, class _Hash, class _Pred, class _Alloc>
inline bool
operator!=(const unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>& __x,
const unordered_multimap<_Key, _Tp, _Hash, _Pred, _Alloc>& __y)
{ return !(__x == __y); }
_GLIBCXX_END_NAMESPACE_CONTAINER
} // namespace std
#endif /* _UNORDERED_MAP_H */
std::unordered_map::max_size
size_type max_size() const noexcept
Returns the maximum size of the unordered_map.
Definition: unordered_map.h:268
std::unordered_multimap::erase
iterator erase(const_iterator __first, const_iterator __last)
Erases a [__first,__last) range of elements from an unordered_multimap.
Definition: unordered_map.h:1212
std::unordered_map::cbegin
const_local_iterator cbegin(size_type __n) const
Returns a read-only (constant) iterator pointing to the first bucket element.
Definition: unordered_map.h:703
std::unordered_map::const_reference
_Hashtable::const_reference const_reference
Iterator-related typedefs.
Definition: unordered_map.h:120
std::unordered_map::key_equal
_Hashtable::key_equal key_equal
Public typedefs.
Definition: unordered_map.h:111
std::unordered_multimap::begin
iterator begin() noexcept
Definition: unordered_map.h:990
std::unordered_multimap::bucket_count
size_type bucket_count() const noexcept
Returns the number of buckets of the unordered_multimap.
Definition: unordered_map.h:1306
std::unordered_map::const_pointer
_Hashtable::const_pointer const_pointer
Iterator-related typedefs.
Definition: unordered_map.h:118
std::unordered_map::local_iterator
_Hashtable::local_iterator local_iterator
Iterator-related typedefs.
Definition: unordered_map.h:123
std::unordered_map::reference
_Hashtable::reference reference
Iterator-related typedefs.
Definition: unordered_map.h:119
std::unordered_multimap::insert
iterator insert(const value_type &__x)
Inserts a std::pair into the unordered_multimap.
Definition: unordered_map.h:1088
std::pair
Struct holding two objects of arbitrary type.
Definition: stl_pair.h:96
std::unordered_map::end
const_iterator end() const noexcept
Definition: unordered_map.h:309
std::unordered_multimap::equal_range
std::pair< const_iterator, const_iterator > equal_range(const key_type &__x) const
Finds a subsequence matching given key.
Definition: unordered_map.h:1298
std::__detail::_Default_ranged_hash
Default ranged hash function H. In principle it should be a function object composed from objects of ...
Definition: hashtable_policy.h:457
std::unordered_multimap::insert
iterator insert(const_iterator __hint, _Pair &&__x)
Inserts a std::pair into the unordered_multimap.
Definition: unordered_map.h:1127
std::unordered_multimap::end
iterator end() noexcept
Definition: unordered_map.h:1012
std::unordered_multimap::cbegin
const_local_iterator cbegin(size_type __n) const
Returns a read-only (constant) iterator pointing to the first bucket element.
Definition: unordered_map.h:1354
std::unordered_multimap::end
const_iterator end() const noexcept
Definition: unordered_map.h:1021
std::unordered_multimap::iterator
_Hashtable::iterator iterator
Iterator-related typedefs.
Definition: unordered_map.h:833
std::unordered_map::clear
void clear() noexcept
Definition: unordered_map.h:527
std::unordered_map::insert
void insert(_InputIterator __first, _InputIterator __last)
A template function that attempts to insert a range of elements.
Definition: unordered_map.h:448
std::unordered_multimap::hasher
_Hashtable::hasher hasher
Public typedefs.
Definition: unordered_map.h:822
std::unordered_multimap::end
const_local_iterator end(size_type __n) const
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
Definition: unordered_map.h:1376
std::unordered_map::count
size_type count(const key_type &__x) const
Finds the number of elements.
Definition: unordered_map.h:591
std::unordered_multimap::insert
void insert(_InputIterator __first, _InputIterator __last)
A template function that attempts to insert a range of elements.
Definition: unordered_map.h:1142
std::unordered_multimap::max_bucket_count
size_type max_bucket_count() const noexcept
Returns the maximum number of buckets of the unordered_multimap.
Definition: unordered_map.h:1311
std::unordered_map::key_type
_Hashtable::key_type key_type
Public typedefs.
Definition: unordered_map.h:107
std::unordered_multimap::mapped_type
_Hashtable::mapped_type mapped_type
Public typedefs.
Definition: unordered_map.h:821
std::unordered_map::reserve
void reserve(size_type __n)
Prepare the unordered_map for a specified number of elements.
Definition: unordered_map.h:773
std::unordered_map::erase
iterator erase(const_iterator __first, const_iterator __last)
Erases a [__first,__last) range of elements from an unordered_map.
Definition: unordered_map.h:517
std::unordered_map::bucket_count
size_type bucket_count() const noexcept
Returns the number of buckets of the unordered_map.
Definition: unordered_map.h:655
std::unordered_map::get_allocator
allocator_type get_allocator() const noexcept
Returns the allocator object with which the unordered_map was constructed.
Definition: unordered_map.h:251
std::unordered_map::end
iterator end() noexcept
Definition: unordered_map.h:300
std::unordered_map::operator[]
mapped_type & operator[](const key_type &__k)
Subscript ( [] ) access to unordered_map data.
Definition: unordered_map.h:626
std::unordered_map::size_type
_Hashtable::size_type size_type
Iterator-related typedefs.
Definition: unordered_map.h:125
std::unordered_map::end
local_iterator end(size_type __n)
Returns a read/write iterator pointing to one past the last bucket elements.
Definition: unordered_map.h:714
std::unordered_map::operator=
unordered_map & operator=(const unordered_map &)=default
Copy assignment operator.
std::iterator
Common iterator class.
Definition: stl_iterator_base_types.h:118
std::__detail::_Prime_rehash_policy
Default value for rehash policy. Bucket size is (usually) the smallest prime that keeps the load fact...
Definition: hashtable_policy.h:461
std::unordered_multimap::erase
iterator erase(iterator __it)
Erases an element from an unordered_multimap.
Definition: unordered_map.h:1177
std::unordered_multimap::end
local_iterator end(size_type __n)
Returns a read/write iterator pointing to one past the last bucket elements.
Definition: unordered_map.h:1365
std::unordered_map::size
size_type size() const noexcept
Returns the size of the unordered_map.
Definition: unordered_map.h:263
std::unordered_multimap::unordered_multimap
unordered_multimap(initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Builds an unordered_multimap from an initializer_list.
Definition: unordered_map.h:926
std::unordered_multimap::key_equal
_Hashtable::key_equal key_equal
Public typedefs.
Definition: unordered_map.h:823
std::unordered_multimap::pointer
_Hashtable::pointer pointer
Iterator-related typedefs.
Definition: unordered_map.h:829
std::unordered_multimap::max_size
size_type max_size() const noexcept
Returns the maximum size of the unordered_multimap.
Definition: unordered_map.h:980
std::unordered_map::mapped_type
_Hashtable::mapped_type mapped_type
Public typedefs.
Definition: unordered_map.h:109
std::unordered_multimap::key_eq
key_equal key_eq() const
Returns the key comparison object with which the unordered_multimap was constructed.
Definition: unordered_map.h:1251
std::unordered_multimap::find
iterator find(const key_type &__x)
Tries to locate an element in an unordered_multimap.
Definition: unordered_map.h:1269
std::unordered_map::end
const_local_iterator end(size_type __n) const
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
Definition: unordered_map.h:725
std::unordered_multimap::unordered_multimap
unordered_multimap(_InputIterator __f, _InputIterator __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Builds an unordered_multimap from a range.
Definition: unordered_map.h:872
std::unordered_map::unordered_map
unordered_map(initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Builds an unordered_map from an initializer_list.
Definition: unordered_map.h:214
std::unordered_map::rehash
void rehash(size_type __n)
May rehash the unordered_map.
Definition: unordered_map.h:762
std::unordered_multimap::local_iterator
_Hashtable::local_iterator local_iterator
Iterator-related typedefs.
Definition: unordered_map.h:835
std::unordered_map::hash_function
hasher hash_function() const
Returns the hash functor object with which the unordered_map was constructed.
Definition: unordered_map.h:549
std::unordered_map::find
iterator find(const key_type &__x)
Tries to locate an element in an unordered_map.
Definition: unordered_map.h:573
std::unordered_map::insert
void insert(initializer_list< value_type > __l)
Attempts to insert a list of elements into the unordered_map.
Definition: unordered_map.h:459
std::unordered_map::insert
iterator insert(const_iterator __hint, _Pair &&__x)
Attempts to insert a std::pair into the unordered_map.
Definition: unordered_map.h:433
std::unordered_multimap::erase
iterator erase(const_iterator __position)
Erases an element from an unordered_multimap.
Definition: unordered_map.h:1172
std::unordered_multimap::reserve
void reserve(size_type __n)
Prepare the unordered_multimap for a specified number of elements.
Definition: unordered_map.h:1424
std::unordered_multimap::load_factor
float load_factor() const noexcept
Returns the average number of elements per bucket.
Definition: unordered_map.h:1388
std::unordered_multimap::count
size_type count(const key_type &__x) const
Finds the number of elements.
Definition: unordered_map.h:1283
std::unordered_map::equal_range
std::pair< iterator, iterator > equal_range(const key_type &__x)
Finds a subsequence matching given key.
Definition: unordered_map.h:604
std::__detail::_Hashtable_traits
Definition: hashtable_policy.h:212
std::unordered_multimap::cbegin
const_iterator cbegin() const noexcept
Definition: unordered_map.h:1003
std::unordered_map::emplace
std::pair< iterator, bool > emplace(_Args &&...__args)
Attempts to build and insert a std::pair into the unordered_map.
Definition: unordered_map.h:340
std::unordered_map::allocator_type
_Hashtable::allocator_type allocator_type
Public typedefs.
Definition: unordered_map.h:112
std::unordered_map::empty
bool empty() const noexcept
Returns true if the unordered_map is empty.
Definition: unordered_map.h:258
std::unordered_map::begin
const_local_iterator begin(size_type __n) const
Returns a read-only (constant) iterator pointing to the first bucket element.
Definition: unordered_map.h:699
std::unordered_map::insert
iterator insert(const_iterator __hint, const value_type &__x)
Attempts to insert a std::pair into the unordered_map.
Definition: unordered_map.h:426
std::unordered_multimap::insert
iterator insert(const_iterator __hint, const value_type &__x)
Inserts a std::pair into the unordered_multimap.
Definition: unordered_map.h:1120
std::unordered_map::iterator
_Hashtable::iterator iterator
Iterator-related typedefs.
Definition: unordered_map.h:121
std::unordered_map::cend
const_local_iterator cend(size_type __n) const
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
Definition: unordered_map.h:729
std::_Hashtable
Definition: bits/hashtable.h:170
std::unordered_map::equal_range
std::pair< const_iterator, const_iterator > equal_range(const key_type &__x) const
Finds a subsequence matching given key.
Definition: unordered_map.h:608
std::unordered_multimap
A standard container composed of equivalent keys (possibly containing multiple of each key value) tha...
Definition: unordered_map.h:810
std::allocator
The standard allocator, as per [20.4].
Definition: allocator.h:92
std::unordered_map::unordered_map
unordered_map(const allocator_type &__a)
Creates an unordered_map with no elements.
Definition: unordered_map.h:179
std::unordered_multimap::clear
void clear() noexcept
Definition: unordered_map.h:1222
std::unordered_multimap::insert
void insert(initializer_list< value_type > __l)
Attempts to insert a list of elements into the unordered_multimap.
Definition: unordered_map.h:1154
std::unordered_multimap::find
const_iterator find(const key_type &__x) const
Tries to locate an element in an unordered_multimap.
Definition: unordered_map.h:1273
std::unordered_multimap::allocator_type
_Hashtable::allocator_type allocator_type
Public typedefs.
Definition: unordered_map.h:824
std::unordered_multimap::erase
size_type erase(const key_type &__x)
Erases elements according to the provided key.
Definition: unordered_map.h:1193
std::unordered_map::unordered_map
unordered_map(_InputIterator __f, _InputIterator __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Builds an unordered_map from a range.
Definition: unordered_map.h:160
std::unordered_map::const_iterator
_Hashtable::const_iterator const_iterator
Iterator-related typedefs.
Definition: unordered_map.h:122
std::unordered_multimap::const_local_iterator
_Hashtable::const_local_iterator const_local_iterator
Iterator-related typedefs.
Definition: unordered_map.h:836
std::unordered_map::cbegin
const_iterator cbegin() const noexcept
Definition: unordered_map.h:291
std::unordered_multimap::insert
iterator insert(_Pair &&__x)
Inserts a std::pair into the unordered_multimap.
Definition: unordered_map.h:1095
std::unordered_map::load_factor
float load_factor() const noexcept
Returns the average number of elements per bucket.
Definition: unordered_map.h:737
std::__detail::_Mod_range_hashing
Default range hashing function: use division to fold a large number into the range [0...
Definition: hashtable_policy.h:440
std::unordered_multimap::equal_range
std::pair< iterator, iterator > equal_range(const key_type &__x)
Finds a subsequence matching given key.
Definition: unordered_map.h:1294
std::unordered_multimap::difference_type
_Hashtable::difference_type difference_type
Iterator-related typedefs.
Definition: unordered_map.h:838
std::unordered_multimap::empty
bool empty() const noexcept
Returns true if the unordered_multimap is empty.
Definition: unordered_map.h:970
std::unordered_map::erase
iterator erase(const_iterator __position)
Erases an element from an unordered_map.
Definition: unordered_map.h:477
std::unordered_multimap::const_iterator
_Hashtable::const_iterator const_iterator
Iterator-related typedefs.
Definition: unordered_map.h:834
std::unordered_map::begin
iterator begin() noexcept
Definition: unordered_map.h:278
std::unordered_map::key_eq
key_equal key_eq() const
Returns the key comparison object with which the unordered_map was constructed.
Definition: unordered_map.h:555
std::unordered_multimap::emplace
iterator emplace(_Args &&...__args)
Attempts to build and insert a std::pair into the unordered_multimap.
Definition: unordered_map.h:1048
std::unordered_map::hasher
_Hashtable::hasher hasher
Public typedefs.
Definition: unordered_map.h:110
std::unordered_multimap::cend
const_iterator cend() const noexcept
Definition: unordered_map.h:1025
std::hash
Primary class template hash.
Definition: system_error:115
std::unordered_map::const_local_iterator
_Hashtable::const_local_iterator const_local_iterator
Iterator-related typedefs.
Definition: unordered_map.h:124
std::unordered_map::operator[]
mapped_type & operator[](key_type &&__k)
Subscript ( [] ) access to unordered_map data.
Definition: unordered_map.h:630
std::unordered_multimap::unordered_multimap
unordered_multimap(size_type __n=10, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Default constructor creates no elements.
Definition: unordered_map.h:851
std::unordered_map::erase
iterator erase(iterator __it)
Erases an element from an unordered_map.
Definition: unordered_map.h:482
std::unordered_map::unordered_map
unordered_map(size_type __n=10, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Default constructor creates no elements.
Definition: unordered_map.h:139
std::unordered_multimap::cend
const_local_iterator cend(size_type __n) const
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
Definition: unordered_map.h:1380
std::unordered_multimap::emplace_hint
iterator emplace_hint(const_iterator __pos, _Args &&...__args)
Attempts to build and insert a std::pair into the unordered_multimap.
Definition: unordered_map.h:1074
std::unordered_multimap::begin
const_local_iterator begin(size_type __n) const
Returns a read-only (constant) iterator pointing to the first bucket element.
Definition: unordered_map.h:1350
std::unordered_multimap::size_type
_Hashtable::size_type size_type
Iterator-related typedefs.
Definition: unordered_map.h:837
std::unordered_multimap::begin
const_iterator begin() const noexcept
Definition: unordered_map.h:999
std::unordered_multimap::swap
void swap(unordered_multimap &__x) noexcept(noexcept(_M_h.swap(__x._M_h)))
Swaps data with another unordered_multimap.
Definition: unordered_map.h:1236
std::initializer_list
initializer_list
Definition: initializer_list:47
std::unordered_map
A standard container composed of unique keys (containing at most one of each key value) that associat...
Definition: unordered_map.h:98
std::unordered_multimap::max_load_factor
void max_load_factor(float __z)
Change the unordered_multimap maximum load factor.
Definition: unordered_map.h:1402
std::unordered_multimap::get_allocator
allocator_type get_allocator() const noexcept
Returns the allocator object with which the unordered_multimap was constructed.
Definition: unordered_map.h:963
std::unordered_map::cend
const_iterator cend() const noexcept
Definition: unordered_map.h:313
std::unordered_multimap::size
size_type size() const noexcept
Returns the size of the unordered_multimap.
Definition: unordered_map.h:975
std::unordered_multimap::operator=
unordered_multimap & operator=(const unordered_multimap &)=default
Copy assignment operator.
std::unordered_map::value_type
_Hashtable::value_type value_type
Public typedefs.
Definition: unordered_map.h:108
std::unordered_map::insert
std::pair< iterator, bool > insert(const value_type &__x)
Attempts to insert a std::pair into the unordered_map.
Definition: unordered_map.h:392
std::unordered_map::pointer
_Hashtable::pointer pointer
Iterator-related typedefs.
Definition: unordered_map.h:117
std::unordered_map::insert
std::pair< iterator, bool > insert(_Pair &&__x)
Attempts to insert a std::pair into the unordered_map.
Definition: unordered_map.h:399
std::unordered_multimap::key_type
_Hashtable::key_type key_type
Public typedefs.
Definition: unordered_map.h:819
std::unordered_map::erase
size_type erase(const key_type &__x)
Erases elements according to the provided key.
Definition: unordered_map.h:499
std::unordered_map::begin
local_iterator begin(size_type __n)
Returns a read/write iterator pointing to the first bucket element.
Definition: unordered_map.h:688
std::unordered_map::difference_type
_Hashtable::difference_type difference_type
Iterator-related typedefs.
Definition: unordered_map.h:126
std::unordered_multimap::reference
_Hashtable::reference reference
Iterator-related typedefs.
Definition: unordered_map.h:831
std::equal_to
One of the comparison functors.
Definition: stl_function.h:336
std::unordered_multimap::begin
local_iterator begin(size_type __n)
Returns a read/write iterator pointing to the first bucket element.
Definition: unordered_map.h:1339
std::unordered_map::max_load_factor
void max_load_factor(float __z)
Change the unordered_map maximum load factor.
Definition: unordered_map.h:751
std::unordered_multimap::rehash
void rehash(size_type __n)
May rehash the unordered_multimap.
Definition: unordered_map.h:1413
std::unordered_multimap::value_type
_Hashtable::value_type value_type
Public typedefs.
Definition: unordered_map.h:820
std::unordered_map::max_load_factor
float max_load_factor() const noexcept
Returns a positive number that the unordered_map tries to keep the load factor less than or equal to...
Definition: unordered_map.h:743
std::unordered_multimap::max_load_factor
float max_load_factor() const noexcept
Returns a positive number that the unordered_multimap tries to keep the load factor less than or equa...
Definition: unordered_map.h:1394
std::unordered_map::at
const mapped_type & at(const key_type &__k) const
Access to unordered_map data.
Definition: unordered_map.h:647
std::unordered_map::begin
const_iterator begin() const noexcept
Definition: unordered_map.h:287
std::unordered_map::find
const_iterator find(const key_type &__x) const
Tries to locate an element in an unordered_map.
Definition: unordered_map.h:577
std::unordered_multimap::const_reference
_Hashtable::const_reference const_reference
Iterator-related typedefs.
Definition: unordered_map.h:832
std::unordered_multimap::hash_function
hasher hash_function() const
Returns the hash functor object with which the unordered_multimap was constructed.
Definition: unordered_map.h:1245
std::unordered_map::swap
void swap(unordered_map &__x) noexcept(noexcept(_M_h.swap(__x._M_h)))
Swaps data with another unordered_map.
Definition: unordered_map.h:540
std::unordered_map::emplace_hint
iterator emplace_hint(const_iterator __pos, _Args &&...__args)
Attempts to build and insert a std::pair into the unordered_map.
Definition: unordered_map.h:370
std::unordered_map::operator=
unordered_map & operator=(initializer_list< value_type > __l)
Unordered_map list assignment operator.
Definition: unordered_map.h:242
std::unordered_map::max_bucket_count
size_type max_bucket_count() const noexcept
Returns the maximum number of buckets of the unordered_map.
Definition: unordered_map.h:660
std::unordered_multimap::const_pointer
_Hashtable::const_pointer const_pointer
Iterator-related typedefs.
Definition: unordered_map.h:830
std::unordered_multimap::operator=
unordered_multimap & operator=(initializer_list< value_type > __l)
Unordered_multimap list assignment operator.
Definition: unordered_map.h:954
std::unordered_multimap::unordered_multimap
unordered_multimap(const allocator_type &__a)
Creates an unordered_multimap with no elements.
Definition: unordered_map.h:891
std::unordered_map::at
mapped_type & at(const key_type &__k)
Access to unordered_map data.
Definition: unordered_map.h:643